//     {}
import java.io.*;import java.lang.*;import javax.swing.JOptionPane;

public class assemblatore{

private final PrintStream outInfo;
private boolean erroriTot;
private boolean errori;

private final String[] cosi;
private final String[][] partiFisse;
private final String[][] partiCondizionate;
private final String[][] partiMen;
private final String[][] partiSottoLink;

private final String[] link;
private final String[] args;
private final String[] directory;
private final String[] aperturaPagineS;
private final String[][] sottoLink;
private final String[][] sottoArgs;
private final String[][] scritturaSottoPagine;
private final String[][] aperturaPagineD;

private final String dirControllo;
private final String dirCreazione;
private final String fileAlbero;
private final String fileScheletro;



public assemblatore (String fileDir,String outputDir,PrintStream outputInfo) throws IOException{

outInfo=outputInfo;
erroriTot=false;

this.dirControllo=fileDir;
this.dirCreazione=outputDir;
this.fileAlbero="struttura.txt";
this.fileScheletro="sorgente.txt";


outInfo.print(fileAlbero+"........");errori=false;
cosi=leggiArray("distribuzione",fileAlbero);
link=leggiArray("link",fileAlbero);
args=leggiArray("argomenti",fileAlbero);
directory=leggiArray("dir",fileAlbero);
aperturaPagineS=leggiArray("aperturaPagineMenuSinistro",fileAlbero);
sottoLink=leggiArray2("sottoLink",fileAlbero);
sottoArgs=leggiArray2("sottoArgomenti",fileAlbero);
scritturaSottoPagine=leggiArray2("scrSottoPagine",fileAlbero);
aperturaPagineD=leggiArray2("aperturaPagineMenuDestro",fileAlbero);
contrErr();

outInfo.print(fileScheletro+"........");errori=false;
partiFisse=creaMatriceStringhe(fileScheletro,"fix");
partiCondizionate=creaMatriceStringhe(fileScheletro,"con");
partiMen=creaMatriceStringhe(fileScheletro,"men");
partiSottoLink=creaMatriceStringhe(fileScheletro,"sub");
contrErr();
}



public void contrErr(){if(errori==false)outInfo.println("OK");else outInfo.println();}


public String[][] creaMatriceStringhe(String nomeFile,String marca) throws IOException{
int nParti=0;
int nChar=marca.length();
for(int a=0;a<this.cosi.length;a++)if(cosi[a].length()>nChar && cosi[a].substring(0,nChar).equals(marca))nParti++;
String[][] ritorno=new String[nParti][];int ind=0;String blocco;
for(int a=0;a<cosi.length;a++)if(cosi[a].length()>nChar && cosi[a].substring(0,nChar).equals(marca)){
	try{
		blocco=cosi[a].substring(nChar+3);
		ritorno[ind]=leggiRighe("<!--"+blocco+"-->","<!--f."+blocco+"-->",true,true,nomeFile);
		ind++;}
	catch(NullPointerException np) {ritorno[ind]=new String[0];outInfo.print("blocco \""+cosi[a]+"\" mancante");ind++;errori=true;erroriTot=true;}
	catch(StringIndexOutOfBoundsException sioobe) {
	outInfo.print("Errore nell'array distribuzione di "+fileAlbero+": controllare la riga \""+cosi[a]+"\"");ritorno[ind]=new String[0];ind++;erroriTot=true;}
	catch(FileNotFoundException fnf) {outInfo.print("File .txt non trovato");erroriTot=true;errori=true;return new String[nParti][0];}
	}
return ritorno;
}




public static String[] leggiRighe(String inizio,String fine,boolean scartoIn,boolean scartoFin,String nomeFile) throws IOException{

class Stringa{
public String str;
public Stringa next;}

BufferedReader br=new BufferedReader(new FileReader(nomeFile));
String lettura=br.readLine();

while(!lettura.equals(inizio))lettura=br.readLine();

Stringa preStringa=new Stringa(); preStringa.next=new Stringa(); int l=1;

for(Stringa variabile=preStringa.next;!lettura.equals(fine);lettura=br.readLine(),l++){
	variabile.str=lettura;variabile.next=new Stringa();variabile=variabile.next;
	}

if (scartoIn==true){l--;preStringa=preStringa.next;}
if(scartoFin==true)l--;
String[] ritorno=new String[l];l=0;
for(Stringa variabile=preStringa.next;l<ritorno.length;variabile=variabile.next,l++)ritorno[l]=variabile.str;
return ritorno;
}


//		{}






public static String[] generaMenu(String[] nomi,String[] link,String[] aperture,String pref,String[] iniz,String[] fine,String pagAtt){
boolean presente=false;
for(int b=0;b<link.length;b++)if(link[b].equals(pagAtt))presente=true;
String[] menu=new String[(iniz.length+fine.length)*(link.length-((presente==false)?0:1))];
int indiceRigaMenu=0;

for(int b=0;b<link.length;b++){
if(link[b].equals(pagAtt))continue;
for(int c=0;c<iniz.length;c++){
menu[indiceRigaMenu]=iniz[c];indiceRigaMenu++;}
menu[--indiceRigaMenu]+=" href=\""+pref+link[b]+"\" target=\""+aperture[b]+"\">"+nomi[b];
indiceRigaMenu++;
for(int c=0;c<fine.length;c++){
menu[indiceRigaMenu]=fine[c];indiceRigaMenu++;}
}
return menu;}


//     {}




public static void stampaArray(String[] nomeArr){
if (nomeArr==null){JOptionPane.showMessageDialog(null,"array nulla");return;}
for(int a=0;a<nomeArr.length;a++)System.out.println(nomeArr[a]);}
public static void stampaArray(String[][] nar){
for(int a=0;a<nar.length;a++)
for(int b=0;b<nar[a].length;b++)
System.out.print(a+" "+b+" =   "+nar[a][b]+"               ");
}




public static String[] leggiArray(String inizio,String nomefile) throws IOException{
return leggiRighe("--"+inizio+"--","-"+inizio+"-",true,true,nomefile);
}


public static String[][] leggiArray2(String inizio,String nomefile) throws IOException{
String[] appezzamento=leggiRighe("----"+inizio+"----","--"+inizio+"--",true,true,nomefile);
int lunghezza=1;
for(int a=0;a<appezzamento.length;a++)if(appezzamento[a].equals("--"))lunghezza++;
String[][] ris=new String[lunghezza][];
int status=1;int primaX=0;int secondaX=0;

for(int a=1;a<appezzamento.length;a++){
if(status==1){
	ris[primaX]=new String[Integer.parseInt(appezzamento[a])];status=2;}
else if(status==2 && !appezzamento[a].equals("--")){
	ris[primaX][secondaX]=appezzamento[a];secondaX++;}
else{primaX++;secondaX=0;status=1;a++;}
}
return ris;
}



public void implementa(String[][] partiVariabili,String[] m1,String[] m2,String nFile,boolean sottoLink) throws IOException{

String[][] ritorno=new String[partiVariabili.length+this.partiFisse.length+1+((m2.length==0)? 0 : (this.partiCondizionate.length+1))+(sottoLink? partiSottoLink.length : 0)][];
int indexP=0;int varIndex=0;int fixIndex=0;int condIndex=0;int subIndex=0;

for(int a=0;indexP<ritorno.length;a++) {
	if(cosi[a].equals("me1")) {ritorno[indexP]=m1;indexP++;}
	else if(cosi[a].equals("me2") && m2.length!=0) {ritorno[indexP]=m2;indexP++;}
	else if(cosi[a].substring(0,3).equals("var")) {ritorno[indexP]=partiVariabili[varIndex];varIndex++;indexP++;}
	else if(cosi[a].substring(0,3).equals("fix")) {ritorno[indexP]=this.partiFisse[fixIndex];fixIndex++;indexP++;}
	else if(cosi[a].substring(0,3).equals("con") && m2.length!=0)
			{ritorno[indexP]=this.partiCondizionate[condIndex];condIndex++;indexP++;}
	else if(cosi[a].substring(0,3).equals("sub") &&  sottoLink) {ritorno[indexP]=this.partiSottoLink[subIndex];subIndex++;indexP++;}
	}

try{
PrintWriter pw=new PrintWriter(new FileWriter(nFile));
for(int a=0;a<ritorno.length;a++)
	for(int b=0;b<ritorno[a].length;b++)
		pw.println(ritorno[a][b]);
pw.close();
}
catch (FileNotFoundException fileNot) {outInfo.println("Devi creare la directory per "+nFile);erroriTot=true;errori=true;}
}




public void esegui() throws IOException{

for(int a=0;a<link.length;a++){
//CICLO PER OGNI FILE ACCESSIBILE DAL MENU PRINCIPALE
String[] menu2=new String[0];

if(sottoLink[a].length>0){
	
	menu2=generaMenu(sottoArgs[a],sottoLink[a],aperturaPagineD[a],directory[a],partiMen[2],partiMen[3],dirControllo+link[a]);

	for(int b=0;b<sottoLink[a].length;b++){
		//CICLO PER I SOTTOLINK DI OGNI FILE ACCESSIBILE DAL MENU PRINC.
		if(!scritturaSottoPagine[a][b].equals("s"))continue;
		this.outInfo.print(directory[a]+sottoLink[a][b]+"........");errori=false;
		String[][] parteMob=creaMatriceStringhe(dirControllo+directory[a]+sottoLink[a][b]+".txt","var");
		String[] menuS=generaMenu(args,link,aperturaPagineS,"../",partiMen[0],partiMen[1],sottoLink[a][b]);
		String[] menuD=generaMenu(sottoArgs[a],sottoLink[a],aperturaPagineD[a],"",partiMen[2],partiMen[3],sottoLink[a][b]);
		implementa(parteMob,menuS,menuD,dirCreazione+directory[a]+sottoLink[a][b],true);
		contrErr();
		}
	}

this.outInfo.print(link[a]+"........");errori=false;

String[] menu=generaMenu(args,link,aperturaPagineS,"",partiMen[0],partiMen[1],link[a]);
String[][] parteMobile=creaMatriceStringhe(dirControllo+link[a]+".txt","var");
implementa(parteMobile,menu,menu2,dirCreazione+link[a],false);
contrErr();
}

//	FINE CICLO
if(erroriTot==false) outInfo.println("\nPagine scritte regolarmente");
}








public static void main(String[]args) throws IOException{

System.out.println();

PrintStream ps;
if(args.length==1) ps=new PrintStream(new FileOutputStream(new File(args[0])));
else ps=new PrintStream(System.out);

assemblatore sallanno=new assemblatore("txt/","sito/",ps);
sallanno.esegui();

if (args.length==1) System.out.println("Il resoconto delle operazioni effettuate e\' disponibile sul file "+args[0]);

System.out.println();
System.out.println("Free Assemblatore by Fernando Tabacchi");
System.out.println("f.tabacchi@tiscali.it   ###   http://xoomer.virgilio.it/webidee");
System.out.println();
System.out.println();
System.out.println("premere invio per uscire");
int pippo=System.in.read();

System.exit(0);
}



}